/*
 * (C) COPYRIGHT 2014 CRZ
 */

/* Includes */

#include "hw_config.h"

/*
 * Name   : UART5_Init
 * Input  : None
 * Output : None
 * Return : None
 */
void UART5_Init(void)
{
    /******************** Clock Enable ********************/
    /* Enable GPIO clock */
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE); 
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE); 

    /* Enable UART5 clocks */
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART5, ENABLE);
    
    /******************** GPIO configure ********************/
    GPIO_InitTypeDef GPIO_InitStructure;

    //PC12 UART5_TX
    //PD2 UART5_RX

    /* Connect PXx to USARTx_Tx*/
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource12, GPIO_AF_UART5);
    /* Connect PXx to USARTx_Rx*/
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource2, GPIO_AF_UART5);

    /* Configure USARTx_Tx as alternate function push-pull */
    GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
    GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    /* Configure USARTx_Rx as input floating */
    GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_Init(GPIOD, &GPIO_InitStructure);    
    
    /******************** Fuction configure ********************/
    
    USART_InitTypeDef USART_InitStructure;

    /* USARTx configuration ------------------------------------------------------*/
    /* USARTx configured as follow:
     - BaudRate = 9600 baud  
     - Word Length = 8 Bits
     - One Stop Bit
     - No parity
     - Hardware flow control disabled (RTS and CTS signals)
     - Receive and transmit enabled
     */
    USART_InitStructure.USART_BaudRate   = 9600;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits   = USART_StopBits_1;
    USART_InitStructure.USART_Parity     = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl
                                         = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode       = USART_Mode_Rx | USART_Mode_Tx;

    /* Configure the USARTx */ 
    USART_Init(UART5, &USART_InitStructure);

    /* Enable the USARTx */
    USART_Cmd(UART5, ENABLE);
}

/*
 * Description : none.
 * Argument(s) : none.
 * Return(s)   : none.
 * Note(s)     : none.
 */
void GPS_Com_Init (void)
{
    UART5_Init();
}

/*
* Description : none.
* Argument(s) : none.
* Return(s)   : none.
* Note(s)     : none.
*/
void Test_GPS_Com(void)
{
    uint8_t ch;

    GPS_Com_Init();

    while(1)
    {
        while(USART_GetFlagStatus(UART5, USART_FLAG_RXNE) == RESET);
        ch = USART_ReceiveData(UART5);                
        printf("%c", ch);                
    }
}

