
/* Includes */

#include "hw_config.h"

/* Defines */

#define  IR_RX_QUEUE_BUFFER_SIZE  200

/* Variables */

// Queue for IR Rx
uint16_t  ir_rx_queue_buffer[IR_RX_QUEUE_BUFFER_SIZE];
uint32_t  ir_rx_queue_point_head = 0;
uint32_t  ir_rx_queue_point_tail = 0;

/* Static Functions */

static void ir_rx_queue_increase_point_value(uint32_t * data_p)
{
    (* data_p) ++;
    if(IR_RX_QUEUE_BUFFER_SIZE == (* data_p))
    {
        (* data_p) = 0;
    }
}

/* Global Functions */

void IrRxQueue_Initialize(void)
{
    ir_rx_queue_point_head = ir_rx_queue_point_tail = 0;
}

// IR Rx Queue

ErrorStatus IrRxQueue_Is_Empty(void)
{
    if(ir_rx_queue_point_head == ir_rx_queue_point_tail)
    {
        return SUCCESS;
    }
    return ERROR;
}

void IrRxQueue_EnQueue(uint16_t data)
{
    ir_rx_queue_buffer[ir_rx_queue_point_head] = data;
    ir_rx_queue_increase_point_value(&ir_rx_queue_point_head);
}

uint16_t IrRxQueue_DeQueue(void)
{
    uint16_t retVal = ir_rx_queue_buffer[ir_rx_queue_point_tail];
    ir_rx_queue_increase_point_value(&ir_rx_queue_point_tail);
    return retVal;
}

